/* -*- Mode: C -*-
 * Simple simulation of an SR-latch.  
 * Ben Moszkowski. 
 * 21 Apr 85 
 *
 */
 
/* run */ define latch_test() = exists S,R,Q,Qbar: {
    S=false and R=false and Q=false and Qbar=false
    and for l in [[true,false],[false,false],[false,true],[true,false],[false,false]] do {
	len(5)
	and S gets l[0] and R gets l[1]
    }
    and Q gets not(R or Qbar)
    and Qbar gets not(S or Q)
    and format("%4S %3S  %3S  %3S\n","Qbar"," Q "," R "," S ")
    and always format("%3S  %3S  %3S  %3S\n",wave(Qbar),wave(Q),wave(R),wave(S))
}.

define wave(A) = {
    if A=false then "|  " else " | "
}.

